#push功能的代理选择用哪种推送工具1.个推 2.小米 3.华为
class PushToolClient
  
  def initialize(opts={})
    opts = HashWithIndifferentAccess.new(opts)
    @user_ids = opts[:user_ids]
    @opts = opts
  end

  def do_push
    Settings.platform = @opts[:app_type] || Settings::DEFAULT
    @push_device_collections ||= UserDevice.where(user_id: @user_ids).group_by(&:platform)

    @igetui_push_device_collections ||= @push_device_collections.group_by(&:device_platform)

    Igetui::Base.new(@igetui_push_device_collections['android'].map(&:device_id), @opts.merge(device_platform: 'android')).perform
    Igetui::Base.new(@igetui_push_device_collections['ios'].map(&:device_id), @opts.merge(device_platform: 'ios')).perform

    #现在好像不用了
    # Push::IgetuiIos.push(@push_collections[:igetui_ios], @opts) if @push_collections[:apns].present?
    # Push::IgetuiAndroid.push(@push_collections[:igetui_android], @opts) if @push_collections[:apns].present?

    Xiaomi::Base.perform(@push_device_collections['xiaomi'].map(&:device_id), @opts[:message]) if @push_device_collections[:xiaomi].present?
    Huawei::Base.perform(@push_device_collections['huawei'].map(&:device_id), @opts[:message]) if @push_device_collections[:huawei].present?
  end
end